%tento skript obsahuje výpocet prenosove funkce metodou s vicecestnym
%sirenim pro topologii se dvema odbockami. Pro samostatné vykreslení grafu
%pro moznost 1-5 cest byla vytvorena funkce pocetcest_2od

%parametry vedeni pro kabel CYKY 3x1,5
u01 = 4*pi*10^-7;
ur1 = 1;
Er1 = 4;
E01 = 0.0000000000088854;
S = 1.5;
id1 = 0.7;
a1 = (sqrt(S/3.14))*(10^-3)
d1 = (2*a1) + (2*id1)*(10^-3)
u02 = 0.0000004*3.14;
ur2 = 0.99999;
Er2 = 4;
E02 = 0.0000000000088854;
c0 = 3*10^8;
%vypocet primarnich parametru
f1  = 3000 :10000: 30000000;
t= 0:0.1:3
Lex = ((ur1*u01)/3.14)*(acosh(d1/(2*a1)))
C1= (pi*Er1*E01)/(acosh(d1/(2*a1)))
R1 = sqrt(((ur2*u02*f1))/(pi*58000000*(a1^2)))*(((d1/(2*a1))/sqrt(((d1/(2*a1))^2)-1)))
G1 = 2*pi*f1*C1*0.06
Lin = (R1)/(2*pi*f1)
L1 = Lin+Lex



ZC1 = sqrt(L1/C1);
ZC2 = sqrt(L1/C1);
ZC3 = sqrt(L1/C1);

ZD = 600; %impedance 1. odbocky
r1B = (((ZC3*ZC2)/(ZC3+ZC2))-ZC1)/(((ZC3*ZC2)/(ZC3+ZC2))+ZC1);
r3B = (((ZC1*ZC2)/(ZC1+ZC2))-ZC3)/(((ZC1*ZC2)/(ZC1+ZC2))+ZC3);
r3D = (ZD-ZC1)/(ZD+ZC1);
t1B = 1 - abs(r1B);
t3B = 1 - abs(r3B);
t3D = 1 - abs(r3D);
%vypocet pro jednu odbocku


l1 = 25;
l2 = 20;
l3 = 15;

di12 = l1 + l2
di22 = l1 + (2*l3) +l2
di32 = l1 + 2*(2)*l3 +l2
di42 = l1 + 2*(3)*l3 +l2
di52 = l1 + 2*(4)*l3 +l2
di62 = l1 + 2*(5)*l3 +l2
di72 = l1 + 2*(6)*l3 +l2
di82 = l1 + 2*(7)*l3 +l2
di92 = l1 + 2*(8)*l3 +l2
di102= l1 + 2*(9)*l3 +l2

g12 = t1B; 
g22 = t1B * r3D * t3D;
g32 = t1B * r3D*(r3D * r3B) * t3D;
g42 = t1B * r3D*((r3D * r3B)^2) * t3D; 
g52 = t1B * r3D*((r3D * r3B)^3) * t3D ;
g62 = t1B * r3D*((r3D * r3B)^4) * t3D; 
g72 = t1B * r3D*((r3D * r3B)^5) * t3D; 
g82 = t1B * r3D*((r3D * r3B)^6) * t3D; 
g92 = t1B * r3D*((r3D * r3B)^7) * t3D; 
g102= t1B * r3D*((r3D * r3B)^8) * t3D; 

ti12 = (di12 * sqrt(Er1))/c0;
ti22 = (di22 * sqrt(Er1))/c0;
ti32 = (di32 * sqrt(Er1))/c0;
ti42 = (di42 * sqrt(Er1))/c0;
ti52 = (di52 * sqrt(Er1))/c0;
ti62 = (di62 * sqrt(Er1))/c0;
ti72= (di72 * sqrt(Er1))/c0;
ti82 = (di82 * sqrt(Er1))/c0;
ti92 = (di92 * sqrt(Er1))/c0;
ti102= (di102* sqrt(Er1))/c0;


%sekundarni parametr
jedna = (R1+(2*j*pi*f1*L1));
dve = (G1+(2*j*pi*f1*C1));
gama = sqrt(jedna.*dve);
alfa = real(gama);
%prenosovu rovnice jedna cesta
H012 = exp(-alfa*di12);
H0112 = exp(-2i*pi*f1*ti12);
H12 = g12*H012.*H0112;

%druha cesta
H022 = exp(-alfa*di22);
H0222 = exp(-2i*pi*f1*ti22);
H2 = g22*H022.*H0222;

%treti cesta
H032 = exp(-alfa*di32);
H0332 = exp(-2i*pi*f1*ti32);
H32 = g32* H032.*H0332;
%ctvrtá cesta
H042 = exp(-alfa*di42);
H0442 = exp(-2i*pi*f1*ti42);
H42 = g42* H042.*H0442;

%pata cesta
H052 = exp(-alfa*di52);
H0552 = exp(-2i*pi*f1*ti52);
H52=g52* H052.*H0552;

%sesta cesta
H062 = exp(-alfa*di62);
H0662 = exp(-2i*pi*f1*ti62);
H62=g62* H062.*H0662;

%sedmá cesta
H072 = exp(-alfa*di72);
H0772= exp(-2i*pi*f1*ti72);
H72=g72*H072.*H0772;

%osmá cesta
H082 = exp(-alfa*di82);
H0882 = exp(-2i*pi*f1*ti82);
H82=g82*H082.*H0882;

%devátá cesta
H092 = exp(-alfa*di92);
H0992 = exp(-2i*pi*f1*ti92);
H92=g92*H092.*H0992;

%desátá cesta
H0102= exp(-alfa*di102);
H01012= exp(-2i*pi*f1*ti102);
H102 =g102*H0102.*H01012;

%přenosová funkce pro 4 cesty
H22=20*log((g12*H012.*H0112)+(g22*H022.*H0222)+(g32* H032.*H0332)+(g42* H042.*H0442))


%prenosová funkce pro dvě cesty
H222 = 20*log((g12*H012.*H0112)+(g22*H022.*H0222));
%přenosová funkce pro jednu cestu
H112 = 20*log(H12);
%přenosová funkce pro tři cesty
H332 = 20*log((g12*H012.*H0112)+(g22*H022.*H0222)+(g32* H032.*H0332))
%přenosová funkce pro 5 cest
H55 = 20*log((g12*H012.*H0112)+(g22*H022.*H0222)+(g32* H032.*H0332)+(g42* H042.*H0442)+(g52*H052.*H0552))
%vypocet fáze
fi=((-2*pi*f1.*ti12)+(-alfa.*di12));

%modul
m2=abs(i2);
figure(5);
hold( 'on');
title('Fázová odezva');
xlabel( '\rightarrow f [Hz]');
ylabel( '\fáze [rad]');
plot(f1,fi);
grid( 'on');

%přenosová funkce pro 4 cesty 1 odbocka
figure(8);
hold( 'on');
title('Přenosová funkce pro jednu odbocku - 4 cesty');
xlabel( '\rightarrow f [Hz]');
ylabel( '\uparrow H [dB]');
plot(f1, H22);
grid( 'on');
%prenosová funkce pro 1 cestu 1 odbocka
figure(9)
hold( 'on');
title('Přenosová funkce pro jednu odbocku - 1');
xlabel( '\rightarrow f [Hz]');
ylabel( '\uparrow H [dB]');
plot(f1, H112);
grid( 'on');
%přenosová funkce pro 2 cesty 1 odbocka
figure(10)
hold( 'on');
title('Přenosová funkce pro jednu odbocku - 2 cesty');
xlabel( '\rightarrow f [Hz]');
ylabel( '\uparrow H [dB]');
plot(f1, H222);
grid( 'on');
%prenosová funkce pro 3 cesty 1 odbocka
figure(11)
hold( 'on');
title('Přenosová funkce pro jednu odbocku - 3 cesty');
xlabel( '\rightarrow f [Hz]');
ylabel( '\uparrow H [dB]');
plot(f1, H332);
grid( 'on');
%prenosová funkce pro 5 cest 1 odbocka
figure(12)
hold( 'on');
title('Přenosová funkce pro jednu odbocku - 5 cest');
xlabel( '\rightarrow f [Hz]');
ylabel( '\uparrow H [dB]');
plot(f1, H55);
grid( 'on');
figure(30);
hold( 'on');
title('Porovnání funkcí');
xlabel( 'Time [us]');
xlabel( '\rightarrow f [Hz]');
ylabel( '\uparrow H [dB]');
plot(f1, H22,'y');
plot(f1, H112,'m');
plot(f1, H222,'b');
plot(f1, H55,'r');
plot(f1, H332,'g');
grid( 'on');